    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ---------------
    028 * TableOrder.java
    029 * ---------------
    030 * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * $Id: TableOrder.java,v 1.5 2005/10/18 13:24:19 mungady Exp $
    036 *
    037 * Changes:
    038 * --------
    039 * 29-Jan-2004 : Version 1 (DG);
    040 *
    041 */
    042
    043package org.jfree.util;
    044
    045import java.io.ObjectStreamException;
    046import java.io.Serializable;
    047
    048/**
    049 * Used to indicate the processing order for a table (by row or by column).
    050 *
    051 * @author David Gilbert
    052 */
    053public final class TableOrder implements Serializable {
    054
    055    /** For serialization. */
    056    private static final long serialVersionUID = 525193294068177057L;
    057
    058    /** By row. */
    059    public static final TableOrder BY_ROW = new TableOrder("TableOrder.BY_ROW");
    060
    061    /** By column. */
    062    public static final TableOrder BY_COLUMN
    063        = new TableOrder("TableOrder.BY_COLUMN");
    064
    065    /** The name. */
    066    private String name;
    067
    068    /**
    069     * Private constructor.
    070     *
    071     * @param name  the name.
    072     */
    073    private TableOrder(String name) {
    074        this.name = name;
    075    }
    076
    077    /**
    078     * Returns a string representing the object.
    079     *
    080     * @return The string.
    081     */
    082    public String toString() {
    083        return this.name;
    084    }
    085
    086    /**
    087     * Returns <code>true</code> if this object is equal to the specified
    088     * object, and <code>false</code> otherwise.
    089     *
    090     * @param obj  the other object.
    091     *
    092     * @return A boolean.
    093     */
    094    public boolean equals(Object obj) {
    095        if (this == obj) {
    096            return true;
    097        }
    098        if (!(obj instanceof TableOrder)) {
    099            return false;
    100        }
    101        TableOrder that = (TableOrder) obj;
    102        if (!this.name.equals(that.name)) {
    103            return false;
    104        }
    105        return true;
    106    }
    107
    108    /**
    109     * Returns a hash code value for the object.
    110     *
    111     * @return The hashcode
    112     */
    113    public int hashCode() {
    114        return this.name.hashCode();
    115    }
    116
    117    /**
    118     * Ensures that serialization returns the unique instances.
    119     *
    120     * @return The object.
    121     *
    122     * @throws ObjectStreamException if there is a problem.
    123     */
    124    private Object readResolve() throws ObjectStreamException {
    125        if (this.equals(TableOrder.BY_ROW)) {
    126            return TableOrder.BY_ROW;
    127        }
    128        else if (this.equals(TableOrder.BY_COLUMN)) {
    129            return TableOrder.BY_COLUMN;
    130        }
    131        return null;
    132    }
    133
    134}